
/*----------------------------------------------------------------------------
 *  Copyright (c) 1991, 1992, 1993, 1994   Ohio University
 *                                         Accelerator Laboratory
 *
 *  This software was partially developed under a United States Government
 *  license described in the Notice file included as part of this distribution
 * 
 *    Ohio University Accelerator Laboratory, Athens, Ohio  45701
 * 
 *    carter@oual3.phy.ohiou.edu   Tel: (614) 593-1984  Fax: (614) 593-1436 
 *    odonnell@oual3.phy.ohiou.edu Tel: (614) 593-1977  Fax: (614) 593-1436 
 *----------------------------------------------------------------------------
 *
 * Authors:
 *
 *	Don Carter
 *      John O'Donnell
 *
 *	Ohio University Accelerator Laboratory
 *
 * Original version DAQ created 1991
 * Revision History:
 *
 *----------------------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <oual.h>
#include <time.h>

/* shared memory support */

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

extern REF_index;
extern REF_id;

int refresh()

{

int chanctr,i;
int start,stop;
unsigned *ptr;

/* printf("refresh entered.\n"); */
if ((int) (shmpltptr = (char *) shmat(REF_id,0,0)) == -1)
  {
  printf("\nshmatt failed in refresh.\n");
  flush();
  return(4);
  }

/* printf("SIGUSR2 recieved by refresh. REF_id = %d.\n",REF_id); */
plotbufferptr = (struct plotbuffer *) shmpltptr;

start = (int)plotbufferptr->start;
stop = plotbufferptr->stop;

chanctr = 0;
ptr = oual_define[REF_index].address;
ptr += start;
for (i=start; i<=stop; i++) plotbufferptr->data[i] = *ptr++;

if(shmdt(shmpltptr) == -1)
  {
  printf("\nshmdt failed in refresh.\n");
  }
/*
if (shmctl(REF_id,IPC_RMID,0) == -1)
  {
  printf("\nshmctl release failed in fpdc.\n");
  }
*/
return(0);
}
