typedef union {
    token                *tok;

    token_list           *toks; 

    node                 *n_node;
    tpd_node             *n_tpd;
    block_node           *n_block; 
    stmt_node            *n_stmt; 
    decl_node            *n_decl; 
    expr_node            *n_expr; 
    expr_group_node      *n_grp; 

    write_param_node     *n_wrtp; 
    write_list_node      *n_wrls; 
    case_node            *n_case; 
    set_item_node        *n_item; 

    const_def_node       *n_cdef; 
    type_def_node        *n_tdef; 
    var_decl_node        *n_vdcl; 

    field_init_node      *n_field;
    
    param_list_node      *n_plist; 
    idx_node             *n_idx; 

    field_list_node      *n_fldls;
    variant_part_node    *n_varp;
    selector_node        *n_sel; 
    variant_node         *n_vari;
    compound_node        *n_comp;
   
    import_list_node     *n_imp; 
} YYSTYPE;
#define	ARRAY	258
#define	BEGIN	259
#define	CASE	260
#define	CONST	261
#define	DO	262
#define	DOTS	263
#define	ELSE	264
#define	END	265
#define	FIL	266
#define	FOR	267
#define	FUNCTION	268
#define	GOTO	269
#define	IDENT	270
#define	ICONST	271
#define	IF	272
#define	IMPLEMENTATION	273
#define	LABEL	274
#define	LET	275
#define	LOOPHOLE	276
#define	OF	277
#define	ORIGIN	278
#define	OTHERWISE	279
#define	PACKED	280
#define	PROCEDURE	281
#define	PROGRAM	282
#define	RCONST	283
#define	READ	284
#define	RECORD	285
#define	REPEAT	286
#define	RETURN	287
#define	SET	288
#define	SCONST	289
#define	STRING	290
#define	THEN	291
#define	TO	292
#define	TYPE	293
#define	UNTIL	294
#define	UNIT	295
#define	UNIT_END	296
#define	VAR	297
#define	WHILE	298
#define	WITH	299
#define	WRITE	300
#define	EQ	301
#define	NE	302
#define	LT	303
#define	LE	304
#define	GT	305
#define	GE	306
#define	IN	307
#define	PLUS	308
#define	MINUS	309
#define	OR	310
#define	XOR	311
#define	MOD	312
#define	DIV	313
#define	DIVR	314
#define	MUL	315
#define	AND	316
#define	SHR	317
#define	SHL	318
#define	UPLUS	319
#define	UMINUS	320
#define	NOT	321


extern YYSTYPE zzlval;
